;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                                                              ;;
;; Copyright (C) KolibriOS team 2004-2011. All rights reserved. ;;
;; Distributed under terms of the GNU General Public License    ;;
;;                                                              ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


format MS COFF

DEBUG	     equ 0

API_VERSION	equ 1

include 'proc32.inc'
include 'imports.inc'

struc IOCTL
{  .handle	dd ?
   .io_code	dd ?
   .input	dd ?
   .inp_size	dd ?
   .output	dd ?
   .out_size	dd ?
}

virtual at 0
  IOCTL IOCTL
end virtual

public START
;public service_proc
public version

DRV_ENTRY    equ 1
DRV_EXIT     equ -1
STRIDE	     equ 4	;size of row in devices table

SRV_GETVERSION	equ 0

section '.flat' code readable align 16

proc START stdcall, state:dword

	cmp	[state], 1
	jne	.exit
.entry:

     if DEBUG
	mov	esi, msgInit
	call	SysMsgBoardStr
     end if

	stdcall RegService, my_service, service_proc
	ret
.fail:
.exit:
	xor	eax, eax
	ret
endp

handle	   equ	IOCTL.handle
io_code    equ	IOCTL.io_code
input	   equ	IOCTL.input
inp_size   equ	IOCTL.inp_size
output	   equ	IOCTL.output
out_size   equ	IOCTL.out_size

align 4
proc service_proc stdcall, ioctl:dword
	push ebx
	mov  ebx,[ioctl]
	mov  eax,[ebx+io_code]
	test eax,eax
	jz .AllocMemAt
	xor eax,eax
	ret
.AllocMemAt:
	mov ebx,[ebx+input]
	stdcall UserAllocAt,[ebx],[ebx+4]
     ;   push eax edi

     ;   xor eax,eax     ;塞  ﬨ
     ;   mov edi,[ebx]
     ;   mov ecx,[ebx+4]
     ;   rep stosb

     ;   pop edi eax
	pop ebx
	ret
endp

restore   handle
restore   io_code
restore   input
restore   inp_size
restore   output
restore   out_size

;all initialized data place here

align 4

version      dd (5 shl 16) or (API_VERSION and 0xFFFF)

my_service   db 'Victoria driver',0  ;max 16 chars include zero

msgInit      db 'Victoria driver start',13,10,0


section '.data' data readable writable align 16

;all uninitialized data place here

